/* Sistemas Integrados TECNISA

Nome: 02CT_GERTRGO.SQL

Descrio:
   Trigger para gravar o log das alteraes

Criao:
   27/04/2006 - Pedro Viol
*/

CREATE OR REPLACE TRIGGER LOG_SUP_PZOPGTITMCOL
AFTER DELETE OR INSERT OR UPDATE
ON PZOPGTITMCOL FOR EACH ROW
DECLARE
  V_DSREMOTEADDR VARCHAR2(15);
  V_DSREMOTEHOST VARCHAR2(15);
  V_DSSERVERRDM  VARCHAR2(20);
  V_DSSERVMETHOD VARCHAR2(30);
  V_DSREMOTEOPER VARCHAR2(12);
  V_DESC         VARCHAR2(500);
  V_CDFILLOGOPER VARCHAR2(4);
  V_ITPESQ       VARCHAR2(80);
  V_NMOPERADOR   VARCHAR2(40);
  V_IDTIPOOPER   VARCHAR2(1);
BEGIN
/* IDTIPOOPER - '1' - Incluso, '2' - Alterao, '3' - Excluso*/
   V_DESC         := '';
   V_ITPESQ       := '';
   V_NMOPERADOR   := '';
   V_IDTIPOOPER   := '';
   V_CDFILLOGOPER := '';
   NMUSUARIO(V_NMOPERADOR);
   WEBTUNNING(V_DSREMOTEADDR,
              V_DSREMOTEHOST,
              V_DSSERVERRDM,
              V_DSSERVMETHOD,
              V_DSREMOTEOPER);
   IF UPDATING THEN
      V_DESC         := 'Prazo(Dias)' || ' ' || :NEW.NRDIASPGTCOL || ' ' ||
                        'Percentual'  || ' ' || :NEW.VRPERCPGTCOL;

      V_ITPESQ       := :NEW.NRDIASPGTCOL || :NEW.CDFILIAL || :NEW.NRCOLEPRECO || :NEW.CDMARCA ||
                        :NEW.CDREGIAO || :NEW.CDFORNECED || :NEW.CDPRODUTO;

      V_CDFILLOGOPER := :NEW.CDFILIAL;
      V_IDTIPOOPER   := '2';
   ELSE
      IF INSERTING THEN
         V_DESC       := 'Prazo(Dias)' || ' ' || :NEW.NRDIASPGTCOL || ' ' ||
                         'Percentual'  || ' ' || :NEW.VRPERCPGTCOL;

         V_ITPESQ     := :NEW.NRDIASPGTCOL || :NEW.CDFILIAL || :NEW.NRCOLEPRECO || :NEW.CDMARCA ||
                         :NEW.CDREGIAO || :NEW.CDFORNECED || :NEW.CDPRODUTO;

         V_CDFILLOGOPER := :NEW.CDFILIAL;
         V_IDTIPOOPER   := '1';
      ELSE
         IF DELETING THEN
            V_DESC   := 'Prazo(Dias)' || ' ' || :NEW.NRDIASPGTCOL || ' ' ||
                        'Percentual'  || ' ' || :NEW.VRPERCPGTCOL;

            V_ITPESQ := :OLD.NRDIASPGTCOL || :OLD.CDFILIAL || :OLD.NRCOLEPRECO || :OLD.CDMARCA ||
                        :OLD.CDREGIAO || :OLD.CDFORNECED || :OLD.CDPRODUTO;

            V_CDFILLOGOPER := :OLD.CDFILIAL;
            V_IDTIPOOPER   := '3';
         END IF;
      END IF;
   END IF;
   V_DESC := SUBSTR(V_DESC, 1, 300);
   INSERT INTO LOGOPERA
      (NMTABELA,
       DTOPERACAO,
       NMRESPOPER,
       IDTIPOOPER,
       DSOPERACAO,
       CDPESQITEM,
       DSRDMUSUOPER,
       DSENDUSUOPER,
       DSNMUSUOPER,
       DSMETUSUOPER,
       CDORESPOPER,
       CDFILLOGOPER)
   VALUES
      ('PZOPGTITMCOL',
       SYSDATE,
       NVL(V_NMOPERADOR,' '),
       V_IDTIPOOPER,
       V_DESC,
       V_ITPESQ,
       V_DSSERVERRDM,
       V_DSREMOTEADDR,
       V_DSREMOTEHOST,
       V_DSSERVMETHOD,
       V_DSREMOTEOPER,
       V_CDFILLOGOPER);
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('LOG_SUP_PZOPGTITMCOL','4.07.051'); END;
/

